import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdCatalogAccessControlConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of Catalog to read
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control#catalog_id DataVcdCatalogAccessControl#catalog_id}
    */
    readonly catalogId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control#id DataVcdCatalogAccessControl#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control#org DataVcdCatalogAccessControl#org}
    */
    readonly org?: string;
}
export interface DataVcdCatalogAccessControlSharedWith {
}
export declare function dataVcdCatalogAccessControlSharedWithToTerraform(struct?: DataVcdCatalogAccessControlSharedWith): any;
export declare function dataVcdCatalogAccessControlSharedWithToHclTerraform(struct?: DataVcdCatalogAccessControlSharedWith): any;
export declare class DataVcdCatalogAccessControlSharedWithOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdCatalogAccessControlSharedWith | undefined;
    set internalValue(value: DataVcdCatalogAccessControlSharedWith | undefined);
    get accessLevel(): string;
    get groupId(): string;
    get orgId(): string;
    get subjectName(): string;
    get userId(): string;
}
export declare class DataVcdCatalogAccessControlSharedWithList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdCatalogAccessControlSharedWithOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control vcd_catalog_access_control}
*/
export declare class DataVcdCatalogAccessControl extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_catalog_access_control";
    /**
    * Generates CDKTF code for importing a DataVcdCatalogAccessControl resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdCatalogAccessControl to import
    * @param importFromId The id of the existing DataVcdCatalogAccessControl that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdCatalogAccessControl to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/catalog_access_control vcd_catalog_access_control} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdCatalogAccessControlConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdCatalogAccessControlConfig);
    private _catalogId?;
    get catalogId(): string;
    set catalogId(value: string);
    get catalogIdInput(): string | undefined;
    get everyoneAccessLevel(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get readOnlySharedWithAllOrgs(): cdktf.IResolvable;
    private _sharedWith;
    get sharedWith(): DataVcdCatalogAccessControlSharedWithList;
    get sharedWithEveryone(): cdktf.IResolvable;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
