import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdDseRegistryConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/dse_registry_configuration#id DataVcdDseRegistryConfiguration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Data Solution Name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/dse_registry_configuration#name DataVcdDseRegistryConfiguration#name}
    */
    readonly name: string;
}
export interface DataVcdDseRegistryConfigurationContainerRegistry {
}
export declare function dataVcdDseRegistryConfigurationContainerRegistryToTerraform(struct?: DataVcdDseRegistryConfigurationContainerRegistry): any;
export declare function dataVcdDseRegistryConfigurationContainerRegistryToHclTerraform(struct?: DataVcdDseRegistryConfigurationContainerRegistry): any;
export declare class DataVcdDseRegistryConfigurationContainerRegistryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdDseRegistryConfigurationContainerRegistry | undefined;
    set internalValue(value: DataVcdDseRegistryConfigurationContainerRegistry | undefined);
    get description(): string;
    get host(): string;
    get password(): string;
    get username(): string;
}
export declare class DataVcdDseRegistryConfigurationContainerRegistryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdDseRegistryConfigurationContainerRegistryOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/dse_registry_configuration vcd_dse_registry_configuration}
*/
export declare class DataVcdDseRegistryConfiguration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_dse_registry_configuration";
    /**
    * Generates CDKTF code for importing a DataVcdDseRegistryConfiguration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdDseRegistryConfiguration to import
    * @param importFromId The id of the existing DataVcdDseRegistryConfiguration that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/dse_registry_configuration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdDseRegistryConfiguration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/dse_registry_configuration vcd_dse_registry_configuration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdDseRegistryConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdDseRegistryConfigurationConfig);
    get chartRepository(): string;
    get compatibleVersionConstraints(): string[];
    private _containerRegistry;
    get containerRegistry(): DataVcdDseRegistryConfigurationContainerRegistryList;
    get defaultChartRepository(): string;
    get defaultPackageName(): string;
    get defaultRepository(): string;
    get defaultVersion(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get packageName(): string;
    get packageRepository(): string;
    get rdeState(): string;
    get requiresVersionCompatibility(): cdktf.IResolvable;
    get type(): string;
    get version(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
