import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdMultisiteSiteAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID of the site to which the associated site belongs
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association#associated_site_id DataVcdMultisiteSiteAssociation#associated_site_id}
    */
    readonly associatedSiteId?: string;
    /**
    * Name of the file filled with association data for this Site. Used when user doesn't have associated site ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association#association_data_file DataVcdMultisiteSiteAssociation#association_data_file}
    */
    readonly associationDataFile?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association#id DataVcdMultisiteSiteAssociation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association vcd_multisite_site_association}
*/
export declare class DataVcdMultisiteSiteAssociation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_multisite_site_association";
    /**
    * Generates CDKTF code for importing a DataVcdMultisiteSiteAssociation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdMultisiteSiteAssociation to import
    * @param importFromId The id of the existing DataVcdMultisiteSiteAssociation that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdMultisiteSiteAssociation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_association vcd_multisite_site_association} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdMultisiteSiteAssociationConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdMultisiteSiteAssociationConfig);
    get associatedSiteHref(): string;
    private _associatedSiteId?;
    get associatedSiteId(): string;
    set associatedSiteId(value: string);
    resetAssociatedSiteId(): void;
    get associatedSiteIdInput(): string | undefined;
    get associatedSiteName(): string;
    private _associationDataFile?;
    get associationDataFile(): string;
    set associationDataFile(value: string);
    resetAssociationDataFile(): void;
    get associationDataFileInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
