import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdMultisiteSiteDataConfig extends cdktf.TerraformMetaArguments {
    /**
    * Name of the file to be filled with association data for this site
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_data#download_to_file DataVcdMultisiteSiteData#download_to_file}
    */
    readonly downloadToFile?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_data#id DataVcdMultisiteSiteData#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_data vcd_multisite_site_data}
*/
export declare class DataVcdMultisiteSiteData extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_multisite_site_data";
    /**
    * Generates CDKTF code for importing a DataVcdMultisiteSiteData resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdMultisiteSiteData to import
    * @param importFromId The id of the existing DataVcdMultisiteSiteData that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_data#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdMultisiteSiteData to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/multisite_site_data vcd_multisite_site_data} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdMultisiteSiteDataConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdMultisiteSiteDataConfig);
    get associationData(): string;
    private _downloadToFile?;
    get downloadToFile(): string;
    set downloadToFile(value: string);
    resetDownloadToFile(): void;
    get downloadToFileInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
