import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_req_rules#id DataVcdNsxtAlbVirtualServiceHttpReqRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_req_rules#virtual_service_id DataVcdNsxtAlbVirtualServiceHttpReqRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | undefined);
    get action(): string;
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect | undefined);
    get host(): string;
    get keepQuery(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get protocol(): string;
    get statusCode(): number;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl | undefined);
    get existingPath(): string;
    get hostHeader(): string;
    get keepQuery(): cdktf.IResolvable;
    get query(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActions {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActions): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActions): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActions | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActions | undefined);
    private _modifyHeader;
    get modifyHeader(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderList;
    private _redirect;
    get redirect(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectList;
    private _rewriteUrl;
    get rewriteUrl(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress | undefined);
    get criteria(): string;
    get ipAddresses(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie | undefined);
    get criteria(): string;
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods | undefined);
    get criteria(): string;
    get methods(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath | undefined);
    get criteria(): string;
    get paths(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | undefined);
    get criteria(): string;
    get name(): string;
    get values(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts | undefined);
    get criteria(): string;
    get ports(): number[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria | undefined);
    private _clientIpAddress;
    get clientIpAddress(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressList;
    private _cookie;
    get cookie(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieList;
    private _httpMethods;
    get httpMethods(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsList;
    private _path;
    get path(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathList;
    get protocolType(): string;
    get query(): string[];
    private _requestHeaders;
    get requestHeaders(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersList;
    private _servicePorts;
    get servicePorts(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpReqRulesRule {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRule): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpReqRulesRuleToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpReqRulesRule): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRule | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpReqRulesRule | undefined);
    private _actions;
    get actions(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleActionsList;
    get active(): cdktf.IResolvable;
    get logging(): cdktf.IResolvable;
    private _matchCriteria;
    get matchCriteria(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaList;
    get name(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_req_rules vcd_nsxt_alb_virtual_service_http_req_rules}
*/
export declare class DataVcdNsxtAlbVirtualServiceHttpReqRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_req_rules";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbVirtualServiceHttpReqRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbVirtualServiceHttpReqRules to import
    * @param importFromId The id of the existing DataVcdNsxtAlbVirtualServiceHttpReqRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_req_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbVirtualServiceHttpReqRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_req_rules vcd_nsxt_alb_virtual_service_http_req_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbVirtualServiceHttpReqRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbVirtualServiceHttpReqRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rule;
    get rule(): DataVcdNsxtAlbVirtualServiceHttpReqRulesRuleList;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
