import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_resp_rules#id DataVcdNsxtAlbVirtualServiceHttpRespRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_resp_rules#virtual_service_id DataVcdNsxtAlbVirtualServiceHttpRespRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | undefined);
    get action(): string;
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader | undefined);
    get host(): string;
    get keepQuery(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get protocol(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActions {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActions): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActions): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActions | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActions | undefined);
    private _modifyHeader;
    get modifyHeader(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderList;
    private _rewriteLocationHeader;
    get rewriteLocationHeader(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress | undefined);
    get criteria(): string;
    get ipAddresses(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie | undefined);
    get criteria(): string;
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods | undefined);
    get criteria(): string;
    get methods(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader | undefined);
    get criteria(): string;
    get values(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath | undefined);
    get criteria(): string;
    get paths(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | undefined);
    get criteria(): string;
    get name(): string;
    get values(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | undefined);
    get criteria(): string;
    get name(): string;
    get values(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts | undefined);
    get criteria(): string;
    get ports(): number[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode | undefined);
    get criteria(): string;
    get httpStatusCode(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria | undefined);
    private _clientIpAddress;
    get clientIpAddress(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressList;
    private _cookie;
    get cookie(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieList;
    private _httpMethods;
    get httpMethods(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsList;
    private _locationHeader;
    get locationHeader(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderList;
    private _path;
    get path(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathList;
    get protocolType(): string;
    get query(): string[];
    private _requestHeaders;
    get requestHeaders(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersList;
    private _responseHeaders;
    get responseHeaders(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersList;
    private _servicePorts;
    get servicePorts(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsList;
    private _statusCode;
    get statusCode(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpRespRulesRule {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRule): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpRespRulesRuleToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpRespRulesRule): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRule | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpRespRulesRule | undefined);
    private _actions;
    get actions(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleActionsList;
    get active(): cdktf.IResolvable;
    get logging(): cdktf.IResolvable;
    private _matchCriteria;
    get matchCriteria(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaList;
    get name(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_resp_rules vcd_nsxt_alb_virtual_service_http_resp_rules}
*/
export declare class DataVcdNsxtAlbVirtualServiceHttpRespRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_resp_rules";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbVirtualServiceHttpRespRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbVirtualServiceHttpRespRules to import
    * @param importFromId The id of the existing DataVcdNsxtAlbVirtualServiceHttpRespRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_resp_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbVirtualServiceHttpRespRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_resp_rules vcd_nsxt_alb_virtual_service_http_resp_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbVirtualServiceHttpRespRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbVirtualServiceHttpRespRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rule;
    get rule(): DataVcdNsxtAlbVirtualServiceHttpRespRulesRuleList;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
