import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_sec_rules#id DataVcdNsxtAlbVirtualServiceHttpSecRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_sec_rules#virtual_service_id DataVcdNsxtAlbVirtualServiceHttpSecRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | undefined);
    get content(): string;
    get contentType(): string;
    get statusCode(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | undefined);
    get host(): string;
    get keepQuery(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get protocol(): string;
    get statusCode(): number;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit | undefined);
    get actionCloseConnection(): cdktf.IResolvable;
    private _actionLocalResponse;
    get actionLocalResponse(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseList;
    private _actionRedirect;
    get actionRedirect(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectList;
    get count(): string;
    get period(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse | undefined);
    get content(): string;
    get contentType(): string;
    get statusCode(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActions {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActions): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActions): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActions | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActions | undefined);
    get connections(): string;
    private _rateLimit;
    get rateLimit(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitList;
    get redirectToHttps(): string;
    private _sendResponse;
    get sendResponse(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress | undefined);
    get criteria(): string;
    get ipAddresses(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie | undefined);
    get criteria(): string;
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods | undefined);
    get criteria(): string;
    get methods(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath | undefined);
    get criteria(): string;
    get paths(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | undefined);
    get criteria(): string;
    get name(): string;
    get values(): string[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts | undefined);
    get criteria(): string;
    get ports(): number[];
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria | undefined);
    private _clientIpAddress;
    get clientIpAddress(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressList;
    private _cookie;
    get cookie(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieList;
    private _httpMethods;
    get httpMethods(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsList;
    private _path;
    get path(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathList;
    get protocolType(): string;
    get query(): string[];
    private _requestHeaders;
    get requestHeaders(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersList;
    private _servicePorts;
    get servicePorts(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsList;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference;
}
export interface DataVcdNsxtAlbVirtualServiceHttpSecRulesRule {
}
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleToTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRule): any;
export declare function dataVcdNsxtAlbVirtualServiceHttpSecRulesRuleToHclTerraform(struct?: DataVcdNsxtAlbVirtualServiceHttpSecRulesRule): any;
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRule | undefined;
    set internalValue(value: DataVcdNsxtAlbVirtualServiceHttpSecRulesRule | undefined);
    private _actions;
    get actions(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleActionsList;
    get active(): cdktf.IResolvable;
    get logging(): cdktf.IResolvable;
    private _matchCriteria;
    get matchCriteria(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaList;
    get name(): string;
}
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_sec_rules vcd_nsxt_alb_virtual_service_http_sec_rules}
*/
export declare class DataVcdNsxtAlbVirtualServiceHttpSecRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_sec_rules";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbVirtualServiceHttpSecRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbVirtualServiceHttpSecRules to import
    * @param importFromId The id of the existing DataVcdNsxtAlbVirtualServiceHttpSecRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_sec_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbVirtualServiceHttpSecRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_alb_virtual_service_http_sec_rules vcd_nsxt_alb_virtual_service_http_sec_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbVirtualServiceHttpSecRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbVirtualServiceHttpSecRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rule;
    get rule(): DataVcdNsxtAlbVirtualServiceHttpSecRulesRuleList;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
