import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtTier0RouterInterfaceConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID of External network (Provider Gateway)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface#external_network_id DataVcdNsxtTier0RouterInterface#external_network_id}
    */
    readonly externalNetworkId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface#id DataVcdNsxtTier0RouterInterface#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of NSX-T Tier-0 Router Interface
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface#name DataVcdNsxtTier0RouterInterface#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface vcd_nsxt_tier0_router_interface}
*/
export declare class DataVcdNsxtTier0RouterInterface extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_tier0_router_interface";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtTier0RouterInterface resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtTier0RouterInterface to import
    * @param importFromId The id of the existing DataVcdNsxtTier0RouterInterface that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtTier0RouterInterface to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/nsxt_tier0_router_interface vcd_nsxt_tier0_router_interface} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtTier0RouterInterfaceConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtTier0RouterInterfaceConfig);
    get description(): string;
    private _externalNetworkId?;
    get externalNetworkId(): string;
    set externalNetworkId(value: string);
    get externalNetworkIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
