import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgVdcTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/org_vdc_template#id DataVcdOrgVdcTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the VDC Template as seen by the System administrator
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/org_vdc_template#name DataVcdOrgVdcTemplate#name}
    */
    readonly name: string;
}
export interface DataVcdOrgVdcTemplateComputeConfiguration {
}
export declare function dataVcdOrgVdcTemplateComputeConfigurationToTerraform(struct?: DataVcdOrgVdcTemplateComputeConfiguration): any;
export declare function dataVcdOrgVdcTemplateComputeConfigurationToHclTerraform(struct?: DataVcdOrgVdcTemplateComputeConfiguration): any;
export declare class DataVcdOrgVdcTemplateComputeConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcTemplateComputeConfiguration | undefined;
    set internalValue(value: DataVcdOrgVdcTemplateComputeConfiguration | undefined);
    get cpuAllocated(): number;
    get cpuGuaranteed(): number;
    get cpuLimit(): number;
    get cpuSpeed(): number;
    get elasticity(): cdktf.IResolvable;
    get includeVmMemoryOverhead(): cdktf.IResolvable;
    get memoryAllocated(): number;
    get memoryGuaranteed(): number;
    get memoryLimit(): number;
}
export declare class DataVcdOrgVdcTemplateComputeConfigurationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcTemplateComputeConfigurationOutputReference;
}
export interface DataVcdOrgVdcTemplateEdgeGatewayStaticIpPool {
}
export declare function dataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolToTerraform(struct?: DataVcdOrgVdcTemplateEdgeGatewayStaticIpPool): any;
export declare function dataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolToHclTerraform(struct?: DataVcdOrgVdcTemplateEdgeGatewayStaticIpPool): any;
export declare class DataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcTemplateEdgeGatewayStaticIpPool | undefined;
    set internalValue(value: DataVcdOrgVdcTemplateEdgeGatewayStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolOutputReference;
}
export interface DataVcdOrgVdcTemplateEdgeGateway {
}
export declare function dataVcdOrgVdcTemplateEdgeGatewayToTerraform(struct?: DataVcdOrgVdcTemplateEdgeGateway): any;
export declare function dataVcdOrgVdcTemplateEdgeGatewayToHclTerraform(struct?: DataVcdOrgVdcTemplateEdgeGateway): any;
export declare class DataVcdOrgVdcTemplateEdgeGatewayOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcTemplateEdgeGateway | undefined;
    set internalValue(value: DataVcdOrgVdcTemplateEdgeGateway | undefined);
    get description(): string;
    get ipAllocationCount(): number;
    get name(): string;
    get routedNetworkDescription(): string;
    get routedNetworkGatewayCidr(): string;
    get routedNetworkName(): string;
    private _staticIpPool;
    get staticIpPool(): DataVcdOrgVdcTemplateEdgeGatewayStaticIpPoolList;
}
export declare class DataVcdOrgVdcTemplateEdgeGatewayList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcTemplateEdgeGatewayOutputReference;
}
export interface DataVcdOrgVdcTemplateProviderVdc {
}
export declare function dataVcdOrgVdcTemplateProviderVdcToTerraform(struct?: DataVcdOrgVdcTemplateProviderVdc): any;
export declare function dataVcdOrgVdcTemplateProviderVdcToHclTerraform(struct?: DataVcdOrgVdcTemplateProviderVdc): any;
export declare class DataVcdOrgVdcTemplateProviderVdcOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcTemplateProviderVdc | undefined;
    set internalValue(value: DataVcdOrgVdcTemplateProviderVdc | undefined);
    get externalNetworkId(): string;
    get gatewayEdgeClusterId(): string;
    get id(): string;
    get servicesEdgeClusterId(): string;
}
export declare class DataVcdOrgVdcTemplateProviderVdcList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcTemplateProviderVdcOutputReference;
}
export interface DataVcdOrgVdcTemplateStorageProfile {
}
export declare function dataVcdOrgVdcTemplateStorageProfileToTerraform(struct?: DataVcdOrgVdcTemplateStorageProfile): any;
export declare function dataVcdOrgVdcTemplateStorageProfileToHclTerraform(struct?: DataVcdOrgVdcTemplateStorageProfile): any;
export declare class DataVcdOrgVdcTemplateStorageProfileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcTemplateStorageProfile | undefined;
    set internalValue(value: DataVcdOrgVdcTemplateStorageProfile | undefined);
    get default(): cdktf.IResolvable;
    get limit(): number;
    get name(): string;
}
export declare class DataVcdOrgVdcTemplateStorageProfileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcTemplateStorageProfileOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/org_vdc_template vcd_org_vdc_template}
*/
export declare class DataVcdOrgVdcTemplate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_vdc_template";
    /**
    * Generates CDKTF code for importing a DataVcdOrgVdcTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgVdcTemplate to import
    * @param importFromId The id of the existing DataVcdOrgVdcTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/org_vdc_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgVdcTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/org_vdc_template vcd_org_vdc_template} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgVdcTemplateConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdOrgVdcTemplateConfig);
    get allocationModel(): string;
    private _computeConfiguration;
    get computeConfiguration(): DataVcdOrgVdcTemplateComputeConfigurationList;
    get description(): string;
    private _edgeGateway;
    get edgeGateway(): DataVcdOrgVdcTemplateEdgeGatewayList;
    get enableFastProvisioning(): cdktf.IResolvable;
    get enableThinProvisioning(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkPoolId(): string;
    get nicQuota(): number;
    private _providerVdc;
    get providerVdc(): DataVcdOrgVdcTemplateProviderVdcList;
    get provisionedNetworkQuota(): number;
    get readableByOrgIds(): string[];
    private _storageProfile;
    get storageProfile(): DataVcdOrgVdcTemplateStorageProfileList;
    get tenantDescription(): string;
    get tenantName(): string;
    get vmQuota(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
