import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdSolutionAddOnInstancePublishConfig extends cdktf.TerraformMetaArguments {
    /**
    * Name of the Solution Add-On Instance
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance_publish#add_on_instance_name DataVcdSolutionAddOnInstancePublish#add_on_instance_name}
    */
    readonly addOnInstanceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance_publish#id DataVcdSolutionAddOnInstancePublish#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance_publish vcd_solution_add_on_instance_publish}
*/
export declare class DataVcdSolutionAddOnInstancePublish extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_solution_add_on_instance_publish";
    /**
    * Generates CDKTF code for importing a DataVcdSolutionAddOnInstancePublish resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdSolutionAddOnInstancePublish to import
    * @param importFromId The id of the existing DataVcdSolutionAddOnInstancePublish that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance_publish#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdSolutionAddOnInstancePublish to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance_publish vcd_solution_add_on_instance_publish} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdSolutionAddOnInstancePublishConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdSolutionAddOnInstancePublishConfig);
    get addOnInstanceId(): string;
    private _addOnInstanceName?;
    get addOnInstanceName(): string;
    set addOnInstanceName(value: string);
    get addOnInstanceNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get orgIds(): string[];
    get publishToAllTenants(): cdktf.IResolvable;
    get rdeState(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
