import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdSolutionAddOnInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance#id DataVcdSolutionAddOnInstance#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Solution Add-On Instance Name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance#name DataVcdSolutionAddOnInstance#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance vcd_solution_add_on_instance}
*/
export declare class DataVcdSolutionAddOnInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_solution_add_on_instance";
    /**
    * Generates CDKTF code for importing a DataVcdSolutionAddOnInstance resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdSolutionAddOnInstance to import
    * @param importFromId The id of the existing DataVcdSolutionAddOnInstance that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdSolutionAddOnInstance to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on_instance vcd_solution_add_on_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdSolutionAddOnInstanceConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdSolutionAddOnInstanceConfig);
    get addOnId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _input;
    get input(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get rdeState(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
