import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdSolutionAddOnConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on#id DataVcdSolutionAddOn#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the Solution Add-On Defined Entity (e.g. 'vmware.ds-1.4.0-23376809')
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on#name DataVcdSolutionAddOn#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on vcd_solution_add_on}
*/
export declare class DataVcdSolutionAddOn extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_solution_add_on";
    /**
    * Generates CDKTF code for importing a DataVcdSolutionAddOn resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdSolutionAddOn to import
    * @param importFromId The id of the existing DataVcdSolutionAddOn that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdSolutionAddOn to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_add_on vcd_solution_add_on} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdSolutionAddOnConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdSolutionAddOnConfig);
    get catalogItemId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get rdeState(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
