import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdSolutionLandingZoneConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_landing_zone#id DataVcdSolutionLandingZone#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_landing_zone#org DataVcdSolutionLandingZone#org}
    */
    readonly org?: string;
}
export interface DataVcdSolutionLandingZoneCatalog {
}
export declare function dataVcdSolutionLandingZoneCatalogToTerraform(struct?: DataVcdSolutionLandingZoneCatalog): any;
export declare function dataVcdSolutionLandingZoneCatalogToHclTerraform(struct?: DataVcdSolutionLandingZoneCatalog): any;
export declare class DataVcdSolutionLandingZoneCatalogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSolutionLandingZoneCatalog | undefined;
    set internalValue(value: DataVcdSolutionLandingZoneCatalog | undefined);
    get capabilities(): string[];
    get id(): string;
    get name(): string;
}
export declare class DataVcdSolutionLandingZoneCatalogList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSolutionLandingZoneCatalogOutputReference;
}
export interface DataVcdSolutionLandingZoneVdcComputePolicy {
}
export declare function dataVcdSolutionLandingZoneVdcComputePolicyToTerraform(struct?: DataVcdSolutionLandingZoneVdcComputePolicy): any;
export declare function dataVcdSolutionLandingZoneVdcComputePolicyToHclTerraform(struct?: DataVcdSolutionLandingZoneVdcComputePolicy): any;
export declare class DataVcdSolutionLandingZoneVdcComputePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSolutionLandingZoneVdcComputePolicy | undefined;
    set internalValue(value: DataVcdSolutionLandingZoneVdcComputePolicy | undefined);
    get capabilities(): string[];
    get id(): string;
    get isDefault(): cdktf.IResolvable;
    get name(): string;
}
export declare class DataVcdSolutionLandingZoneVdcComputePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSolutionLandingZoneVdcComputePolicyOutputReference;
}
export interface DataVcdSolutionLandingZoneVdcOrgVdcNetwork {
}
export declare function dataVcdSolutionLandingZoneVdcOrgVdcNetworkToTerraform(struct?: DataVcdSolutionLandingZoneVdcOrgVdcNetwork): any;
export declare function dataVcdSolutionLandingZoneVdcOrgVdcNetworkToHclTerraform(struct?: DataVcdSolutionLandingZoneVdcOrgVdcNetwork): any;
export declare class DataVcdSolutionLandingZoneVdcOrgVdcNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSolutionLandingZoneVdcOrgVdcNetwork | undefined;
    set internalValue(value: DataVcdSolutionLandingZoneVdcOrgVdcNetwork | undefined);
    get capabilities(): string[];
    get id(): string;
    get isDefault(): cdktf.IResolvable;
    get name(): string;
}
export declare class DataVcdSolutionLandingZoneVdcOrgVdcNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSolutionLandingZoneVdcOrgVdcNetworkOutputReference;
}
export interface DataVcdSolutionLandingZoneVdcStoragePolicy {
}
export declare function dataVcdSolutionLandingZoneVdcStoragePolicyToTerraform(struct?: DataVcdSolutionLandingZoneVdcStoragePolicy): any;
export declare function dataVcdSolutionLandingZoneVdcStoragePolicyToHclTerraform(struct?: DataVcdSolutionLandingZoneVdcStoragePolicy): any;
export declare class DataVcdSolutionLandingZoneVdcStoragePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSolutionLandingZoneVdcStoragePolicy | undefined;
    set internalValue(value: DataVcdSolutionLandingZoneVdcStoragePolicy | undefined);
    get capabilities(): string[];
    get id(): string;
    get isDefault(): cdktf.IResolvable;
    get name(): string;
}
export declare class DataVcdSolutionLandingZoneVdcStoragePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSolutionLandingZoneVdcStoragePolicyOutputReference;
}
export interface DataVcdSolutionLandingZoneVdc {
}
export declare function dataVcdSolutionLandingZoneVdcToTerraform(struct?: DataVcdSolutionLandingZoneVdc): any;
export declare function dataVcdSolutionLandingZoneVdcToHclTerraform(struct?: DataVcdSolutionLandingZoneVdc): any;
export declare class DataVcdSolutionLandingZoneVdcOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSolutionLandingZoneVdc | undefined;
    set internalValue(value: DataVcdSolutionLandingZoneVdc | undefined);
    get capabilities(): string[];
    private _computePolicy;
    get computePolicy(): DataVcdSolutionLandingZoneVdcComputePolicyList;
    get id(): string;
    get isDefault(): cdktf.IResolvable;
    get name(): string;
    private _orgVdcNetwork;
    get orgVdcNetwork(): DataVcdSolutionLandingZoneVdcOrgVdcNetworkList;
    private _storagePolicy;
    get storagePolicy(): DataVcdSolutionLandingZoneVdcStoragePolicyList;
}
export declare class DataVcdSolutionLandingZoneVdcList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSolutionLandingZoneVdcOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_landing_zone vcd_solution_landing_zone}
*/
export declare class DataVcdSolutionLandingZone extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_solution_landing_zone";
    /**
    * Generates CDKTF code for importing a DataVcdSolutionLandingZone resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdSolutionLandingZone to import
    * @param importFromId The id of the existing DataVcdSolutionLandingZone that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_landing_zone#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdSolutionLandingZone to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/data-sources/solution_landing_zone vcd_solution_landing_zone} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdSolutionLandingZoneConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdSolutionLandingZoneConfig);
    private _catalog;
    get catalog(): DataVcdSolutionLandingZoneCatalogList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get state(): string;
    private _vdc;
    get vdc(): DataVcdSolutionLandingZoneVdcList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
