import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MultisiteOrgAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID of the associated Organization
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#associated_org_id MultisiteOrgAssociation#associated_org_id}
    */
    readonly associatedOrgId?: string;
    /**
    * Data needed to associate this Organization to another
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#association_data MultisiteOrgAssociation#association_data}
    */
    readonly associationData?: string;
    /**
    * Name of the file filled with association data for this Org
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#association_data_file MultisiteOrgAssociation#association_data_file}
    */
    readonly associationDataFile?: string;
    /**
    * How many minutes to keep checking for connection (0=no check)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#connection_timeout_mins MultisiteOrgAssociation#connection_timeout_mins}
    */
    readonly connectionTimeoutMins?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#id MultisiteOrgAssociation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Organization ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#org_id MultisiteOrgAssociation#org_id}
    */
    readonly orgId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association vcd_multisite_org_association}
*/
export declare class MultisiteOrgAssociation extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_multisite_org_association";
    /**
    * Generates CDKTF code for importing a MultisiteOrgAssociation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the MultisiteOrgAssociation to import
    * @param importFromId The id of the existing MultisiteOrgAssociation that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the MultisiteOrgAssociation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/multisite_org_association vcd_multisite_org_association} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MultisiteOrgAssociationConfig
    */
    constructor(scope: Construct, id: string, config: MultisiteOrgAssociationConfig);
    private _associatedOrgId?;
    get associatedOrgId(): string;
    set associatedOrgId(value: string);
    resetAssociatedOrgId(): void;
    get associatedOrgIdInput(): string | undefined;
    get associatedOrgName(): string;
    get associatedSiteId(): string;
    private _associationData?;
    get associationData(): string;
    set associationData(value: string);
    resetAssociationData(): void;
    get associationDataInput(): string | undefined;
    private _associationDataFile?;
    get associationDataFile(): string;
    set associationDataFile(value: string);
    resetAssociationDataFile(): void;
    get associationDataFileInput(): string | undefined;
    private _connectionTimeoutMins?;
    get connectionTimeoutMins(): number;
    set connectionTimeoutMins(value: number);
    resetConnectionTimeoutMins(): void;
    get connectionTimeoutMinsInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
