import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbVirtualServiceHttpReqRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#id NsxtAlbVirtualServiceHttpReqRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#virtual_service_id NsxtAlbVirtualServiceHttpReqRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#rule NsxtAlbVirtualServiceHttpReqRules#rule}
    */
    readonly rule: NsxtAlbVirtualServiceHttpReqRulesRule[] | cdktf.IResolvable;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader {
    /**
    * One of the following HTTP header actions. Options - ADD, REMOVE, REPLACE
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#action NsxtAlbVirtualServiceHttpReqRules#action}
    */
    readonly action: string;
    /**
    * HTTP header name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#name NsxtAlbVirtualServiceHttpReqRules#name}
    */
    readonly name: string;
    /**
    * HTTP header value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#value NsxtAlbVirtualServiceHttpReqRules#value}
    */
    readonly value?: string;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader | cdktf.IResolvable | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderOutputReference;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect {
    /**
    * Host to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#host NsxtAlbVirtualServiceHttpReqRules#host}
    */
    readonly host?: string;
    /**
    * Should the query part be preserved
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#keep_query NsxtAlbVirtualServiceHttpReqRules#keep_query}
    */
    readonly keepQuery?: boolean | cdktf.IResolvable;
    /**
    * Path to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#path NsxtAlbVirtualServiceHttpReqRules#path}
    */
    readonly path?: string;
    /**
    * Port to which redirect the request. Default is 80 for HTTP and 443 for HTTPS protocol
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#port NsxtAlbVirtualServiceHttpReqRules#port}
    */
    readonly port?: string;
    /**
    * HTTP or HTTPS protocol
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#protocol NsxtAlbVirtualServiceHttpReqRules#protocol}
    */
    readonly protocol: string;
    /**
    * One of the redirect status codes - 301, 302, 307
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#status_code NsxtAlbVirtualServiceHttpReqRules#status_code}
    */
    readonly statusCode: number;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _keepQuery?;
    get keepQuery(): boolean | cdktf.IResolvable;
    set keepQuery(value: boolean | cdktf.IResolvable);
    resetKeepQuery(): void;
    get keepQueryInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _port?;
    get port(): string;
    set port(value: string);
    resetPort(): void;
    get portInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    get statusCodeInput(): number | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl {
    /**
    * Path to use for the rewritten URL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#existing_path NsxtAlbVirtualServiceHttpReqRules#existing_path}
    */
    readonly existingPath: string;
    /**
    * Host to use for the rewritten URL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#host_header NsxtAlbVirtualServiceHttpReqRules#host_header}
    */
    readonly hostHeader: string;
    /**
    * Whether or not to keep the existing query string when rewriting the URL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#keep_query NsxtAlbVirtualServiceHttpReqRules#keep_query}
    */
    readonly keepQuery?: boolean | cdktf.IResolvable;
    /**
    * Query string to use or append to the existing query string in the rewritten URL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#query NsxtAlbVirtualServiceHttpReqRules#query}
    */
    readonly query?: string;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl | undefined);
    private _existingPath?;
    get existingPath(): string;
    set existingPath(value: string);
    get existingPathInput(): string | undefined;
    private _hostHeader?;
    get hostHeader(): string;
    set hostHeader(value: string);
    get hostHeaderInput(): string | undefined;
    private _keepQuery?;
    get keepQuery(): boolean | cdktf.IResolvable;
    set keepQuery(value: boolean | cdktf.IResolvable);
    resetKeepQuery(): void;
    get keepQueryInput(): boolean | cdktf.IResolvable | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    resetQuery(): void;
    get queryInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleActions {
    /**
    * modify_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#modify_header NsxtAlbVirtualServiceHttpReqRules#modify_header}
    */
    readonly modifyHeader?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader[] | cdktf.IResolvable;
    /**
    * redirect block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#redirect NsxtAlbVirtualServiceHttpReqRules#redirect}
    */
    readonly redirect?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect;
    /**
    * rewrite_url block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#rewrite_url NsxtAlbVirtualServiceHttpReqRules#rewrite_url}
    */
    readonly rewriteUrl?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActions): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleActionsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleActions): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleActions | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleActions | undefined);
    private _modifyHeader;
    get modifyHeader(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeaderList;
    putModifyHeader(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader[] | cdktf.IResolvable): void;
    resetModifyHeader(): void;
    get modifyHeaderInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpReqRulesRuleActionsModifyHeader[] | undefined;
    private _redirect;
    get redirect(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirectOutputReference;
    putRedirect(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect): void;
    resetRedirect(): void;
    get redirectInput(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRedirect | undefined;
    private _rewriteUrl;
    get rewriteUrl(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrlOutputReference;
    putRewriteUrl(value: NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl): void;
    resetRewriteUrl(): void;
    get rewriteUrlInput(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsRewriteUrl | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of IP addresses
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#ip_addresses NsxtAlbVirtualServiceHttpReqRules#ip_addresses}
    */
    readonly ipAddresses: string[];
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ipAddresses?;
    get ipAddresses(): string[];
    set ipAddresses(value: string[]);
    get ipAddressesInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie {
    /**
    * Criteria to use for matching cookies in the HTTP request. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP cookie whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#name NsxtAlbVirtualServiceHttpReqRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP cookie
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#value NsxtAlbVirtualServiceHttpReqRules#value}
    */
    readonly value: string;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * HTTP methods to match. Options - GET, PUT, POST, DELETE, HEAD, OPTIONS, TRACE, CONNECT, PATCH, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#methods NsxtAlbVirtualServiceHttpReqRules#methods}
    */
    readonly methods: string[];
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _methods?;
    get methods(): string[];
    set methods(value: string[]);
    get methodsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath {
    /**
    * Criteria to use for matching the path in the HTTP request URI. Options - BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL, REGEX_MATCH, REGEX_DOES_NOT_MATCH
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * String values to match the path
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#paths NsxtAlbVirtualServiceHttpReqRules#paths}
    */
    readonly paths: string[];
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _paths?;
    get paths(): string[];
    set paths(value: string[]);
    get pathsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders {
    /**
    * Criteria to use for matching headers and cookies in the HTTP request amd response. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP header whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#name NsxtAlbVirtualServiceHttpReqRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP header
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#values NsxtAlbVirtualServiceHttpReqRules#values}
    */
    readonly values: string[];
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#criteria NsxtAlbVirtualServiceHttpReqRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of TCP ports. Allowed values are 1-65535
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#ports NsxtAlbVirtualServiceHttpReqRules#ports}
    */
    readonly ports: number[];
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ports?;
    get ports(): number[];
    set ports(value: number[]);
    get portsInput(): number[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria {
    /**
    * Protocol to match - 'HTTP' or 'HTTPS'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#protocol_type NsxtAlbVirtualServiceHttpReqRules#protocol_type}
    */
    readonly protocolType?: string;
    /**
    * HTTP request query strings to match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#query NsxtAlbVirtualServiceHttpReqRules#query}
    */
    readonly query?: string[];
    /**
    * client_ip_address block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#client_ip_address NsxtAlbVirtualServiceHttpReqRules#client_ip_address}
    */
    readonly clientIpAddress?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress;
    /**
    * cookie block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#cookie NsxtAlbVirtualServiceHttpReqRules#cookie}
    */
    readonly cookie?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie;
    /**
    * http_methods block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#http_methods NsxtAlbVirtualServiceHttpReqRules#http_methods}
    */
    readonly httpMethods?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods;
    /**
    * path block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#path NsxtAlbVirtualServiceHttpReqRules#path}
    */
    readonly path?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath;
    /**
    * request_headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#request_headers NsxtAlbVirtualServiceHttpReqRules#request_headers}
    */
    readonly requestHeaders?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * service_ports block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#service_ports NsxtAlbVirtualServiceHttpReqRules#service_ports}
    */
    readonly servicePorts?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria | undefined);
    private _protocolType?;
    get protocolType(): string;
    set protocolType(value: string);
    resetProtocolType(): void;
    get protocolTypeInput(): string | undefined;
    private _query?;
    get query(): string[];
    set query(value: string[]);
    resetQuery(): void;
    get queryInput(): string[] | undefined;
    private _clientIpAddress;
    get clientIpAddress(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddressOutputReference;
    putClientIpAddress(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress): void;
    resetClientIpAddress(): void;
    get clientIpAddressInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaClientIpAddress | undefined;
    private _cookie;
    get cookie(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookieOutputReference;
    putCookie(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie): void;
    resetCookie(): void;
    get cookieInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaCookie | undefined;
    private _httpMethods;
    get httpMethods(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethodsOutputReference;
    putHttpMethods(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods): void;
    resetHttpMethods(): void;
    get httpMethodsInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaHttpMethods | undefined;
    private _path;
    get path(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPathOutputReference;
    putPath(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath): void;
    resetPath(): void;
    get pathInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaPath | undefined;
    private _requestHeaders;
    get requestHeaders(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeadersList;
    putRequestHeaders(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable): void;
    resetRequestHeaders(): void;
    get requestHeadersInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaRequestHeaders[] | undefined;
    private _servicePorts;
    get servicePorts(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePortsOutputReference;
    putServicePorts(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts): void;
    resetServicePorts(): void;
    get servicePortsInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaServicePorts | undefined;
}
export interface NsxtAlbVirtualServiceHttpReqRulesRule {
    /**
    * Defines if the rule is active or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#active NsxtAlbVirtualServiceHttpReqRules#active}
    */
    readonly active?: boolean | cdktf.IResolvable;
    /**
    * Defines whether to enable logging with headers on rule match or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#logging NsxtAlbVirtualServiceHttpReqRules#logging}
    */
    readonly logging?: boolean | cdktf.IResolvable;
    /**
    * Name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#name NsxtAlbVirtualServiceHttpReqRules#name}
    */
    readonly name: string;
    /**
    * actions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#actions NsxtAlbVirtualServiceHttpReqRules#actions}
    */
    readonly actions: NsxtAlbVirtualServiceHttpReqRulesRuleActions;
    /**
    * match_criteria block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#match_criteria NsxtAlbVirtualServiceHttpReqRules#match_criteria}
    */
    readonly matchCriteria: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria;
}
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleToTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRule | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpReqRulesRuleToHclTerraform(struct?: NsxtAlbVirtualServiceHttpReqRulesRule | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpReqRulesRule | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpReqRulesRule | cdktf.IResolvable | undefined);
    private _active?;
    get active(): boolean | cdktf.IResolvable;
    set active(value: boolean | cdktf.IResolvable);
    resetActive(): void;
    get activeInput(): boolean | cdktf.IResolvable | undefined;
    private _logging?;
    get logging(): boolean | cdktf.IResolvable;
    set logging(value: boolean | cdktf.IResolvable);
    resetLogging(): void;
    get loggingInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _actions;
    get actions(): NsxtAlbVirtualServiceHttpReqRulesRuleActionsOutputReference;
    putActions(value: NsxtAlbVirtualServiceHttpReqRulesRuleActions): void;
    get actionsInput(): NsxtAlbVirtualServiceHttpReqRulesRuleActions | undefined;
    private _matchCriteria;
    get matchCriteria(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteriaOutputReference;
    putMatchCriteria(value: NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria): void;
    get matchCriteriaInput(): NsxtAlbVirtualServiceHttpReqRulesRuleMatchCriteria | undefined;
}
export declare class NsxtAlbVirtualServiceHttpReqRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpReqRulesRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpReqRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules vcd_nsxt_alb_virtual_service_http_req_rules}
*/
export declare class NsxtAlbVirtualServiceHttpReqRules extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_req_rules";
    /**
    * Generates CDKTF code for importing a NsxtAlbVirtualServiceHttpReqRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbVirtualServiceHttpReqRules to import
    * @param importFromId The id of the existing NsxtAlbVirtualServiceHttpReqRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbVirtualServiceHttpReqRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_req_rules vcd_nsxt_alb_virtual_service_http_req_rules} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbVirtualServiceHttpReqRulesConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbVirtualServiceHttpReqRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    private _rule;
    get rule(): NsxtAlbVirtualServiceHttpReqRulesRuleList;
    putRule(value: NsxtAlbVirtualServiceHttpReqRulesRule[] | cdktf.IResolvable): void;
    get ruleInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpReqRulesRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
