import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbVirtualServiceHttpRespRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#id NsxtAlbVirtualServiceHttpRespRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#virtual_service_id NsxtAlbVirtualServiceHttpRespRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#rule NsxtAlbVirtualServiceHttpRespRules#rule}
    */
    readonly rule: NsxtAlbVirtualServiceHttpRespRulesRule[] | cdktf.IResolvable;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader {
    /**
    * One of the following HTTP header actions. Options - ADD, REMOVE, REPLACE
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#action NsxtAlbVirtualServiceHttpRespRules#action}
    */
    readonly action: string;
    /**
    * HTTP header name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#name NsxtAlbVirtualServiceHttpRespRules#name}
    */
    readonly name: string;
    /**
    * HTTP header value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#value NsxtAlbVirtualServiceHttpRespRules#value}
    */
    readonly value?: string;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader | cdktf.IResolvable | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderOutputReference;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader {
    /**
    * Host to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#host NsxtAlbVirtualServiceHttpRespRules#host}
    */
    readonly host?: string;
    /**
    * Should the query part be preserved
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#keep_query NsxtAlbVirtualServiceHttpRespRules#keep_query}
    */
    readonly keepQuery?: boolean | cdktf.IResolvable;
    /**
    * Path to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#path NsxtAlbVirtualServiceHttpRespRules#path}
    */
    readonly path?: string;
    /**
    * Port to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#port NsxtAlbVirtualServiceHttpRespRules#port}
    */
    readonly port: string;
    /**
    * HTTP or HTTPS protocol
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#protocol NsxtAlbVirtualServiceHttpRespRules#protocol}
    */
    readonly protocol: string;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _keepQuery?;
    get keepQuery(): boolean | cdktf.IResolvable;
    set keepQuery(value: boolean | cdktf.IResolvable);
    resetKeepQuery(): void;
    get keepQueryInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _port?;
    get port(): string;
    set port(value: string);
    get portInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleActions {
    /**
    * modify_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#modify_header NsxtAlbVirtualServiceHttpRespRules#modify_header}
    */
    readonly modifyHeader?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader[] | cdktf.IResolvable;
    /**
    * rewrite_location_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#rewrite_location_header NsxtAlbVirtualServiceHttpRespRules#rewrite_location_header}
    */
    readonly rewriteLocationHeader?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleActions): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleActionsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleActions): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleActions | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleActions | undefined);
    private _modifyHeader;
    get modifyHeader(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeaderList;
    putModifyHeader(value: NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader[] | cdktf.IResolvable): void;
    resetModifyHeader(): void;
    get modifyHeaderInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpRespRulesRuleActionsModifyHeader[] | undefined;
    private _rewriteLocationHeader;
    get rewriteLocationHeader(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeaderOutputReference;
    putRewriteLocationHeader(value: NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader): void;
    resetRewriteLocationHeader(): void;
    get rewriteLocationHeaderInput(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsRewriteLocationHeader | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of IP addresses
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#ip_addresses NsxtAlbVirtualServiceHttpRespRules#ip_addresses}
    */
    readonly ipAddresses: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ipAddresses?;
    get ipAddresses(): string[];
    set ipAddresses(value: string[]);
    get ipAddressesInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie {
    /**
    * Criteria to use for matching cookies in the HTTP request. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP cookie whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#name NsxtAlbVirtualServiceHttpRespRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP cookie
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#value NsxtAlbVirtualServiceHttpRespRules#value}
    */
    readonly value: string;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * HTTP methods to match. Options - GET, PUT, POST, DELETE, HEAD, OPTIONS, TRACE, CONNECT, PATCH, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#methods NsxtAlbVirtualServiceHttpRespRules#methods}
    */
    readonly methods: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _methods?;
    get methods(): string[];
    set methods(value: string[]);
    get methodsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader {
    /**
    * Criteria to use for matching location header. Options - BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL, REGEX_MATCH, REGEX_DOES_NOT_MATCH
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of values to match for criteria
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#values NsxtAlbVirtualServiceHttpRespRules#values}
    */
    readonly values: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath {
    /**
    * Criteria to use for matching the path in the HTTP request URI. Options - BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL, REGEX_MATCH, REGEX_DOES_NOT_MATCH
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * String values to match the path
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#paths NsxtAlbVirtualServiceHttpRespRules#paths}
    */
    readonly paths: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _paths?;
    get paths(): string[];
    set paths(value: string[]);
    get pathsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders {
    /**
    * Criteria to use for matching headers and cookies in the HTTP request amd response. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP header whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#name NsxtAlbVirtualServiceHttpRespRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP header
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#values NsxtAlbVirtualServiceHttpRespRules#values}
    */
    readonly values: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders {
    /**
    * Criteria to use for matching headers and cookies in the HTTP request amd response. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP header whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#name NsxtAlbVirtualServiceHttpRespRules#name}
    */
    readonly name?: string;
    /**
    * A set of values to match for an HTTP header
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#values NsxtAlbVirtualServiceHttpRespRules#values}
    */
    readonly values?: string[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders | cdktf.IResolvable | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    resetValues(): void;
    get valuesInput(): string[] | undefined;
}
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersOutputReference;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of TCP ports. Allowed values are 1-65535
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#ports NsxtAlbVirtualServiceHttpRespRules#ports}
    */
    readonly ports: number[];
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ports?;
    get ports(): number[];
    set ports(value: number[]);
    get portsInput(): number[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#criteria NsxtAlbVirtualServiceHttpRespRules#criteria}
    */
    readonly criteria: string;
    /**
    * Enter a http status code or range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#http_status_code NsxtAlbVirtualServiceHttpRespRules#http_status_code}
    */
    readonly httpStatusCode: string;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _httpStatusCode?;
    get httpStatusCode(): string;
    set httpStatusCode(value: string);
    get httpStatusCodeInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria {
    /**
    * Protocol to match - 'HTTP' or 'HTTPS'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#protocol_type NsxtAlbVirtualServiceHttpRespRules#protocol_type}
    */
    readonly protocolType?: string;
    /**
    * HTTP request query strings to match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#query NsxtAlbVirtualServiceHttpRespRules#query}
    */
    readonly query?: string[];
    /**
    * client_ip_address block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#client_ip_address NsxtAlbVirtualServiceHttpRespRules#client_ip_address}
    */
    readonly clientIpAddress?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress;
    /**
    * cookie block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#cookie NsxtAlbVirtualServiceHttpRespRules#cookie}
    */
    readonly cookie?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie;
    /**
    * http_methods block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#http_methods NsxtAlbVirtualServiceHttpRespRules#http_methods}
    */
    readonly httpMethods?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods;
    /**
    * location_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#location_header NsxtAlbVirtualServiceHttpRespRules#location_header}
    */
    readonly locationHeader?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader;
    /**
    * path block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#path NsxtAlbVirtualServiceHttpRespRules#path}
    */
    readonly path?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath;
    /**
    * request_headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#request_headers NsxtAlbVirtualServiceHttpRespRules#request_headers}
    */
    readonly requestHeaders?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * response_headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#response_headers NsxtAlbVirtualServiceHttpRespRules#response_headers}
    */
    readonly responseHeaders?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders[] | cdktf.IResolvable;
    /**
    * service_ports block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#service_ports NsxtAlbVirtualServiceHttpRespRules#service_ports}
    */
    readonly servicePorts?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts;
    /**
    * status_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#status_code NsxtAlbVirtualServiceHttpRespRules#status_code}
    */
    readonly statusCode?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria | undefined);
    private _protocolType?;
    get protocolType(): string;
    set protocolType(value: string);
    resetProtocolType(): void;
    get protocolTypeInput(): string | undefined;
    private _query?;
    get query(): string[];
    set query(value: string[]);
    resetQuery(): void;
    get queryInput(): string[] | undefined;
    private _clientIpAddress;
    get clientIpAddress(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddressOutputReference;
    putClientIpAddress(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress): void;
    resetClientIpAddress(): void;
    get clientIpAddressInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaClientIpAddress | undefined;
    private _cookie;
    get cookie(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookieOutputReference;
    putCookie(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie): void;
    resetCookie(): void;
    get cookieInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaCookie | undefined;
    private _httpMethods;
    get httpMethods(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethodsOutputReference;
    putHttpMethods(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods): void;
    resetHttpMethods(): void;
    get httpMethodsInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaHttpMethods | undefined;
    private _locationHeader;
    get locationHeader(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeaderOutputReference;
    putLocationHeader(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader): void;
    resetLocationHeader(): void;
    get locationHeaderInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaLocationHeader | undefined;
    private _path;
    get path(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPathOutputReference;
    putPath(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath): void;
    resetPath(): void;
    get pathInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaPath | undefined;
    private _requestHeaders;
    get requestHeaders(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeadersList;
    putRequestHeaders(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable): void;
    resetRequestHeaders(): void;
    get requestHeadersInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaRequestHeaders[] | undefined;
    private _responseHeaders;
    get responseHeaders(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeadersList;
    putResponseHeaders(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders[] | cdktf.IResolvable): void;
    resetResponseHeaders(): void;
    get responseHeadersInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaResponseHeaders[] | undefined;
    private _servicePorts;
    get servicePorts(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePortsOutputReference;
    putServicePorts(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts): void;
    resetServicePorts(): void;
    get servicePortsInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaServicePorts | undefined;
    private _statusCode;
    get statusCode(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCodeOutputReference;
    putStatusCode(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode): void;
    resetStatusCode(): void;
    get statusCodeInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaStatusCode | undefined;
}
export interface NsxtAlbVirtualServiceHttpRespRulesRule {
    /**
    * Defines if the rule is active or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#active NsxtAlbVirtualServiceHttpRespRules#active}
    */
    readonly active?: boolean | cdktf.IResolvable;
    /**
    * Defines whether to enable logging with headers on rule match or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#logging NsxtAlbVirtualServiceHttpRespRules#logging}
    */
    readonly logging?: boolean | cdktf.IResolvable;
    /**
    * Name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#name NsxtAlbVirtualServiceHttpRespRules#name}
    */
    readonly name: string;
    /**
    * actions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#actions NsxtAlbVirtualServiceHttpRespRules#actions}
    */
    readonly actions: NsxtAlbVirtualServiceHttpRespRulesRuleActions;
    /**
    * match_criteria block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#match_criteria NsxtAlbVirtualServiceHttpRespRules#match_criteria}
    */
    readonly matchCriteria: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria;
}
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleToTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRule | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpRespRulesRuleToHclTerraform(struct?: NsxtAlbVirtualServiceHttpRespRulesRule | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpRespRulesRule | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpRespRulesRule | cdktf.IResolvable | undefined);
    private _active?;
    get active(): boolean | cdktf.IResolvable;
    set active(value: boolean | cdktf.IResolvable);
    resetActive(): void;
    get activeInput(): boolean | cdktf.IResolvable | undefined;
    private _logging?;
    get logging(): boolean | cdktf.IResolvable;
    set logging(value: boolean | cdktf.IResolvable);
    resetLogging(): void;
    get loggingInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _actions;
    get actions(): NsxtAlbVirtualServiceHttpRespRulesRuleActionsOutputReference;
    putActions(value: NsxtAlbVirtualServiceHttpRespRulesRuleActions): void;
    get actionsInput(): NsxtAlbVirtualServiceHttpRespRulesRuleActions | undefined;
    private _matchCriteria;
    get matchCriteria(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteriaOutputReference;
    putMatchCriteria(value: NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria): void;
    get matchCriteriaInput(): NsxtAlbVirtualServiceHttpRespRulesRuleMatchCriteria | undefined;
}
export declare class NsxtAlbVirtualServiceHttpRespRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpRespRulesRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpRespRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules vcd_nsxt_alb_virtual_service_http_resp_rules}
*/
export declare class NsxtAlbVirtualServiceHttpRespRules extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_resp_rules";
    /**
    * Generates CDKTF code for importing a NsxtAlbVirtualServiceHttpRespRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbVirtualServiceHttpRespRules to import
    * @param importFromId The id of the existing NsxtAlbVirtualServiceHttpRespRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbVirtualServiceHttpRespRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_resp_rules vcd_nsxt_alb_virtual_service_http_resp_rules} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbVirtualServiceHttpRespRulesConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbVirtualServiceHttpRespRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    private _rule;
    get rule(): NsxtAlbVirtualServiceHttpRespRulesRuleList;
    putRule(value: NsxtAlbVirtualServiceHttpRespRulesRule[] | cdktf.IResolvable): void;
    get ruleInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpRespRulesRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
