import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbVirtualServiceHttpSecRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#id NsxtAlbVirtualServiceHttpSecRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Virtual Service ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#virtual_service_id NsxtAlbVirtualServiceHttpSecRules#virtual_service_id}
    */
    readonly virtualServiceId: string;
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#rule NsxtAlbVirtualServiceHttpSecRules#rule}
    */
    readonly rule: NsxtAlbVirtualServiceHttpSecRulesRule[] | cdktf.IResolvable;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse {
    /**
    * Base64 encoded content
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#content NsxtAlbVirtualServiceHttpSecRules#content}
    */
    readonly content?: string;
    /**
    * MIME type for the content
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#content_type NsxtAlbVirtualServiceHttpSecRules#content_type}
    */
    readonly contentType?: string;
    /**
    * HTTP Status code to send
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#status_code NsxtAlbVirtualServiceHttpSecRules#status_code}
    */
    readonly statusCode: string;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse | cdktf.IResolvable | undefined);
    private _content?;
    get content(): string;
    set content(value: string);
    resetContent(): void;
    get contentInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): string;
    set statusCode(value: string);
    get statusCodeInput(): string | undefined;
}
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseOutputReference;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect {
    /**
    * Host to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#host NsxtAlbVirtualServiceHttpSecRules#host}
    */
    readonly host?: string;
    /**
    * Should the query part be preserved
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#keep_query NsxtAlbVirtualServiceHttpSecRules#keep_query}
    */
    readonly keepQuery?: boolean | cdktf.IResolvable;
    /**
    * Path to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#path NsxtAlbVirtualServiceHttpSecRules#path}
    */
    readonly path?: string;
    /**
    * Port to which redirect the request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#port NsxtAlbVirtualServiceHttpSecRules#port}
    */
    readonly port: string;
    /**
    * HTTP or HTTPS protocol
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#protocol NsxtAlbVirtualServiceHttpSecRules#protocol}
    */
    readonly protocol: string;
    /**
    * One of the redirect status codes - 301, 302, 307
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#status_code NsxtAlbVirtualServiceHttpSecRules#status_code}
    */
    readonly statusCode: number;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect | cdktf.IResolvable | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _keepQuery?;
    get keepQuery(): boolean | cdktf.IResolvable;
    set keepQuery(value: boolean | cdktf.IResolvable);
    resetKeepQuery(): void;
    get keepQueryInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _port?;
    get port(): string;
    set port(value: string);
    get portInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    get statusCodeInput(): number | undefined;
}
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectOutputReference;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit {
    /**
    * Set to true if the connection should be closed
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#action_close_connection NsxtAlbVirtualServiceHttpSecRules#action_close_connection}
    */
    readonly actionCloseConnection?: boolean | cdktf.IResolvable;
    /**
    * Maximum number of connections, requests or packets permitted each period. The count must be between 1 and 1000000000
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#count NsxtAlbVirtualServiceHttpSecRules#count}
    */
    readonly count: string;
    /**
    * Time value in seconds to enforce rate count. The period must be between 1 and 1000000000
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#period NsxtAlbVirtualServiceHttpSecRules#period}
    */
    readonly period: string;
    /**
    * action_local_response block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#action_local_response NsxtAlbVirtualServiceHttpSecRules#action_local_response}
    */
    readonly actionLocalResponse?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse[] | cdktf.IResolvable;
    /**
    * action_redirect block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#action_redirect NsxtAlbVirtualServiceHttpSecRules#action_redirect}
    */
    readonly actionRedirect?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect[] | cdktf.IResolvable;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit | undefined);
    private _actionCloseConnection?;
    get actionCloseConnection(): boolean | cdktf.IResolvable;
    set actionCloseConnection(value: boolean | cdktf.IResolvable);
    resetActionCloseConnection(): void;
    get actionCloseConnectionInput(): boolean | cdktf.IResolvable | undefined;
    private _count?;
    get count(): string;
    set count(value: string);
    get countInput(): string | undefined;
    private _period?;
    get period(): string;
    set period(value: string);
    get periodInput(): string | undefined;
    private _actionLocalResponse;
    get actionLocalResponse(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponseList;
    putActionLocalResponse(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse[] | cdktf.IResolvable): void;
    resetActionLocalResponse(): void;
    get actionLocalResponseInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionLocalResponse[] | undefined;
    private _actionRedirect;
    get actionRedirect(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirectList;
    putActionRedirect(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect[] | cdktf.IResolvable): void;
    resetActionRedirect(): void;
    get actionRedirectInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitActionRedirect[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse {
    /**
    * Base64 encoded content
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#content NsxtAlbVirtualServiceHttpSecRules#content}
    */
    readonly content?: string;
    /**
    * MIME type for the content
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#content_type NsxtAlbVirtualServiceHttpSecRules#content_type}
    */
    readonly contentType?: string;
    /**
    * HTTP Status code to send
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#status_code NsxtAlbVirtualServiceHttpSecRules#status_code}
    */
    readonly statusCode: string;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse | undefined);
    private _content?;
    get content(): string;
    set content(value: string);
    resetContent(): void;
    get contentInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): string;
    set statusCode(value: string);
    get statusCodeInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleActions {
    /**
    * ALLOW or CLOSE connections
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#connections NsxtAlbVirtualServiceHttpSecRules#connections}
    */
    readonly connections?: string;
    /**
    * Port number that should be redirected to HTTPS
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#redirect_to_https NsxtAlbVirtualServiceHttpSecRules#redirect_to_https}
    */
    readonly redirectToHttps?: string;
    /**
    * rate_limit block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#rate_limit NsxtAlbVirtualServiceHttpSecRules#rate_limit}
    */
    readonly rateLimit?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit;
    /**
    * send_response block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#send_response NsxtAlbVirtualServiceHttpSecRules#send_response}
    */
    readonly sendResponse?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActions): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleActionsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleActions): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleActions | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleActions | undefined);
    private _connections?;
    get connections(): string;
    set connections(value: string);
    resetConnections(): void;
    get connectionsInput(): string | undefined;
    private _redirectToHttps?;
    get redirectToHttps(): string;
    set redirectToHttps(value: string);
    resetRedirectToHttps(): void;
    get redirectToHttpsInput(): string | undefined;
    private _rateLimit;
    get rateLimit(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimitOutputReference;
    putRateLimit(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit): void;
    resetRateLimit(): void;
    get rateLimitInput(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsRateLimit | undefined;
    private _sendResponse;
    get sendResponse(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponseOutputReference;
    putSendResponse(value: NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse): void;
    resetSendResponse(): void;
    get sendResponseInput(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsSendResponse | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of IP addresses
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#ip_addresses NsxtAlbVirtualServiceHttpSecRules#ip_addresses}
    */
    readonly ipAddresses: string[];
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ipAddresses?;
    get ipAddresses(): string[];
    set ipAddresses(value: string[]);
    get ipAddressesInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie {
    /**
    * Criteria to use for matching cookies in the HTTP request. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP cookie whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#name NsxtAlbVirtualServiceHttpSecRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP cookie
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#value NsxtAlbVirtualServiceHttpSecRules#value}
    */
    readonly value: string;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * HTTP methods to match. Options - GET, PUT, POST, DELETE, HEAD, OPTIONS, TRACE, CONNECT, PATCH, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#methods NsxtAlbVirtualServiceHttpSecRules#methods}
    */
    readonly methods: string[];
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _methods?;
    get methods(): string[];
    set methods(value: string[]);
    get methodsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath {
    /**
    * Criteria to use for matching the path in the HTTP request URI. Options - BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL, REGEX_MATCH, REGEX_DOES_NOT_MATCH
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * String values to match the path
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#paths NsxtAlbVirtualServiceHttpSecRules#paths}
    */
    readonly paths: string[];
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _paths?;
    get paths(): string[];
    set paths(value: string[]);
    get pathsInput(): string[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders {
    /**
    * Criteria to use for matching headers and cookies in the HTTP request amd response. Options - EXISTS, DOES_NOT_EXIST, BEGINS_WITH, DOES_NOT_BEGIN_WITH, CONTAINS, DOES_NOT_CONTAIN, ENDS_WITH, DOES_NOT_END_WITH, EQUALS, DOES_NOT_EQUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * Name of the HTTP header whose value is to be matched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#name NsxtAlbVirtualServiceHttpSecRules#name}
    */
    readonly name: string;
    /**
    * String values to match for an HTTP header
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#values NsxtAlbVirtualServiceHttpSecRules#values}
    */
    readonly values: string[];
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders | cdktf.IResolvable | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersOutputReference;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts {
    /**
    * Criteria to use for IP address matching the HTTP request. Options - IS_IN, IS_NOT_IN
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#criteria NsxtAlbVirtualServiceHttpSecRules#criteria}
    */
    readonly criteria: string;
    /**
    * A set of TCP ports. Allowed values are 1-65535
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#ports NsxtAlbVirtualServiceHttpSecRules#ports}
    */
    readonly ports: number[];
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts | undefined);
    private _criteria?;
    get criteria(): string;
    set criteria(value: string);
    get criteriaInput(): string | undefined;
    private _ports?;
    get ports(): number[];
    set ports(value: number[]);
    get portsInput(): number[] | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria {
    /**
    * Protocol to match - 'HTTP' or 'HTTPS'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#protocol_type NsxtAlbVirtualServiceHttpSecRules#protocol_type}
    */
    readonly protocolType?: string;
    /**
    * HTTP request query strings to match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#query NsxtAlbVirtualServiceHttpSecRules#query}
    */
    readonly query?: string[];
    /**
    * client_ip_address block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#client_ip_address NsxtAlbVirtualServiceHttpSecRules#client_ip_address}
    */
    readonly clientIpAddress?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress;
    /**
    * cookie block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#cookie NsxtAlbVirtualServiceHttpSecRules#cookie}
    */
    readonly cookie?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie;
    /**
    * http_methods block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#http_methods NsxtAlbVirtualServiceHttpSecRules#http_methods}
    */
    readonly httpMethods?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods;
    /**
    * path block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#path NsxtAlbVirtualServiceHttpSecRules#path}
    */
    readonly path?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath;
    /**
    * request_headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#request_headers NsxtAlbVirtualServiceHttpSecRules#request_headers}
    */
    readonly requestHeaders?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable;
    /**
    * service_ports block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#service_ports NsxtAlbVirtualServiceHttpSecRules#service_ports}
    */
    readonly servicePorts?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria | undefined);
    private _protocolType?;
    get protocolType(): string;
    set protocolType(value: string);
    resetProtocolType(): void;
    get protocolTypeInput(): string | undefined;
    private _query?;
    get query(): string[];
    set query(value: string[]);
    resetQuery(): void;
    get queryInput(): string[] | undefined;
    private _clientIpAddress;
    get clientIpAddress(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddressOutputReference;
    putClientIpAddress(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress): void;
    resetClientIpAddress(): void;
    get clientIpAddressInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaClientIpAddress | undefined;
    private _cookie;
    get cookie(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookieOutputReference;
    putCookie(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie): void;
    resetCookie(): void;
    get cookieInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaCookie | undefined;
    private _httpMethods;
    get httpMethods(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethodsOutputReference;
    putHttpMethods(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods): void;
    resetHttpMethods(): void;
    get httpMethodsInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaHttpMethods | undefined;
    private _path;
    get path(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPathOutputReference;
    putPath(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath): void;
    resetPath(): void;
    get pathInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaPath | undefined;
    private _requestHeaders;
    get requestHeaders(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeadersList;
    putRequestHeaders(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders[] | cdktf.IResolvable): void;
    resetRequestHeaders(): void;
    get requestHeadersInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaRequestHeaders[] | undefined;
    private _servicePorts;
    get servicePorts(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePortsOutputReference;
    putServicePorts(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts): void;
    resetServicePorts(): void;
    get servicePortsInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaServicePorts | undefined;
}
export interface NsxtAlbVirtualServiceHttpSecRulesRule {
    /**
    * Defines is the rule is active or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#active NsxtAlbVirtualServiceHttpSecRules#active}
    */
    readonly active?: boolean | cdktf.IResolvable;
    /**
    * Defines whether to enable logging with headers on rule match or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#logging NsxtAlbVirtualServiceHttpSecRules#logging}
    */
    readonly logging?: boolean | cdktf.IResolvable;
    /**
    * Name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#name NsxtAlbVirtualServiceHttpSecRules#name}
    */
    readonly name: string;
    /**
    * actions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#actions NsxtAlbVirtualServiceHttpSecRules#actions}
    */
    readonly actions: NsxtAlbVirtualServiceHttpSecRulesRuleActions;
    /**
    * match_criteria block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#match_criteria NsxtAlbVirtualServiceHttpSecRules#match_criteria}
    */
    readonly matchCriteria: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria;
}
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleToTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRule | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceHttpSecRulesRuleToHclTerraform(struct?: NsxtAlbVirtualServiceHttpSecRulesRule | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceHttpSecRulesRule | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceHttpSecRulesRule | cdktf.IResolvable | undefined);
    private _active?;
    get active(): boolean | cdktf.IResolvable;
    set active(value: boolean | cdktf.IResolvable);
    resetActive(): void;
    get activeInput(): boolean | cdktf.IResolvable | undefined;
    private _logging?;
    get logging(): boolean | cdktf.IResolvable;
    set logging(value: boolean | cdktf.IResolvable);
    resetLogging(): void;
    get loggingInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _actions;
    get actions(): NsxtAlbVirtualServiceHttpSecRulesRuleActionsOutputReference;
    putActions(value: NsxtAlbVirtualServiceHttpSecRulesRuleActions): void;
    get actionsInput(): NsxtAlbVirtualServiceHttpSecRulesRuleActions | undefined;
    private _matchCriteria;
    get matchCriteria(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteriaOutputReference;
    putMatchCriteria(value: NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria): void;
    get matchCriteriaInput(): NsxtAlbVirtualServiceHttpSecRulesRuleMatchCriteria | undefined;
}
export declare class NsxtAlbVirtualServiceHttpSecRulesRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceHttpSecRulesRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceHttpSecRulesRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules vcd_nsxt_alb_virtual_service_http_sec_rules}
*/
export declare class NsxtAlbVirtualServiceHttpSecRules extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service_http_sec_rules";
    /**
    * Generates CDKTF code for importing a NsxtAlbVirtualServiceHttpSecRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbVirtualServiceHttpSecRules to import
    * @param importFromId The id of the existing NsxtAlbVirtualServiceHttpSecRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbVirtualServiceHttpSecRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/nsxt_alb_virtual_service_http_sec_rules vcd_nsxt_alb_virtual_service_http_sec_rules} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbVirtualServiceHttpSecRulesConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbVirtualServiceHttpSecRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _virtualServiceId?;
    get virtualServiceId(): string;
    set virtualServiceId(value: string);
    get virtualServiceIdInput(): string | undefined;
    private _rule;
    get rule(): NsxtAlbVirtualServiceHttpSecRulesRuleList;
    putRule(value: NsxtAlbVirtualServiceHttpSecRulesRule[] | cdktf.IResolvable): void;
    get ruleInput(): cdktf.IResolvable | NsxtAlbVirtualServiceHttpSecRulesRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
