import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SolutionAddOnInstancePublishConfig extends cdktf.TerraformMetaArguments {
    /**
    * Solution Add-On Instance ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish#add_on_instance_id SolutionAddOnInstancePublish#add_on_instance_id}
    */
    readonly addOnInstanceId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish#id SolutionAddOnInstancePublish#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A set of Organization IDs
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish#org_ids SolutionAddOnInstancePublish#org_ids}
    */
    readonly orgIds?: string[];
    /**
    * Publish Solution Add-On Instance to all tenants
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish#publish_to_all_tenants SolutionAddOnInstancePublish#publish_to_all_tenants}
    */
    readonly publishToAllTenants?: boolean | cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish vcd_solution_add_on_instance_publish}
*/
export declare class SolutionAddOnInstancePublish extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_solution_add_on_instance_publish";
    /**
    * Generates CDKTF code for importing a SolutionAddOnInstancePublish resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SolutionAddOnInstancePublish to import
    * @param importFromId The id of the existing SolutionAddOnInstancePublish that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SolutionAddOnInstancePublish to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.14.1/docs/resources/solution_add_on_instance_publish vcd_solution_add_on_instance_publish} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SolutionAddOnInstancePublishConfig
    */
    constructor(scope: Construct, id: string, config: SolutionAddOnInstancePublishConfig);
    private _addOnInstanceId?;
    get addOnInstanceId(): string;
    set addOnInstanceId(value: string);
    get addOnInstanceIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _orgIds?;
    get orgIds(): string[];
    set orgIds(value: string[]);
    resetOrgIds(): void;
    get orgIdsInput(): string[] | undefined;
    private _publishToAllTenants?;
    get publishToAllTenants(): boolean | cdktf.IResolvable;
    set publishToAllTenants(value: boolean | cdktf.IResolvable);
    resetPublishToAllTenants(): void;
    get publishToAllTenantsInput(): boolean | cdktf.IResolvable | undefined;
    get rdeState(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
